/*
 *	nr|X^wUWOOO p[\iEBhEpVOi䃉Cu[
 *
 *						By WADACHI in moto0717@motokho-net
 *									  pde02650@nifty-serve
 *
 *			91/??/?? VER.1.00	first release
 *
 */
#include	<stdio.h>
#include	<modes.h>
#include	<pwindow.h>
#include	"PwGraph.h"
#include	"PwControl.h"
#include	"PwSignal.h"
#include	"PwToolKit.h"

#define	PWSIGBUFSIZE	128
#define	EXCL_OFF		0
#define	EXCL_ON			1

#define	ESC				'\033'

int			ExclFlag = EXCL_OFF;
PWSIGNAL	PwSigBuf[PWSIGBUFSIZE];

int		PwSignalCode = 0;

int		PwSigIn = 0;
int		PwSigOut = 0;
int		PwSleepTick = 0;

/*
	@  \F	Window VOiIB
*/
int		PwSelectSignal(pwin,mask)
PWIN	*pwin;
int		mask;
{
	int		ret;
	
	if (pwin == (PWIN *)NULL){
		return -1;
	}

	pwin->sigmask = mask;
	if (_pw_signal(pwin->path,WIN_DEF_ID,pwin->sigbase,0) != 0){
		return -1;
	}
	if (_pw_signal(pwin->path,WIN_DEF_ID,pwin->sigbase,mask&(~WIN_KEYIN)) != 0){
		return -1;
	}
	if (mask & WIN_KEYIN){
		ret = _ss_ssig(pwin->path, pwin->sigbase + WIN_KEYIN_B);
	}else{
		ret = _ss_rel(pwin->path);
	}

	return ret;
}

/*
	@  \F	VOi擾B
*/
int		PwGetSignal(sigrec)
PWSIGNAL	*sigrec;
{
	PWIN	*win;
	int		x,y;

	if (sigrec == (PWSIGNAL *)NULL){
		return -1;
	}

	if (PwSigIn == PwSigOut){

		tsleep(PwSleepTick);

		if (PwSigIn == PwSigOut){
			win = PwGetRootWin();	
			sigrec->status = _pw_pos(win->path,&x,&y);
			sigrec->type = WIN_INTERVAL_T;
			sigrec->win = win;
			sigrec->key = -1;
			sigrec->x = x;
			sigrec->y = y;
			return 0;
		}
	}

	if (PwSigBuf[PwSigOut].type == WIN_KEYIN_T && \
		PwSigBuf[PwSigOut].key == -1 ){
		SetKeyCode();
		_ss_ssig(PwSigBuf[PwSigOut].win->path, \
				 PwSigBuf[PwSigOut].win->sigbase + WIN_KEYIN_B);
	}

	sigrec->type = PwSigBuf[PwSigOut].type;
	sigrec->win = PwSigBuf[PwSigOut].win;
	sigrec->key = PwSigBuf[PwSigOut].key;
	sigrec->x = PwSigBuf[PwSigOut].x;
	sigrec->y = PwSigBuf[PwSigOut].y;
	sigrec->status = PwSigBuf[PwSigOut].status;

	PwSigOut++;
	if (PWSIGBUFSIZE <= PwSigOut){
		PwSigOut = 0;
	}

	return 0;
}

int		SetKeyCode()
{
	unsigned char	ch;

	if (ExclFlag == EXCL_ON){
		return 0;
	}
	ExclFlag = EXCL_ON;

	if (0 < _gs_rdy(PwSigBuf[PwSigOut].win->path)){
		if (read(PwSigBuf[PwSigOut].win->path, &ch, 1) <= 0){
			ch = ESC;
		}
		PwSigBuf[PwSigOut].key = ch;
	}

	while (0 < _gs_rdy(PwSigBuf[PwSigOut].win->path)){
		if (read(PwSigBuf[PwSigOut].win->path, &ch, 1) <= 0){
			ch = ESC;
		}
		PwSigBuf[PwSigIn].type = PwSigBuf[PwSigOut].type;
		PwSigBuf[PwSigIn].win = PwSigBuf[PwSigOut].win;
		PwSigBuf[PwSigIn].key = ch;
		PwSigBuf[PwSigIn].x = PwSigBuf[PwSigOut].x;
		PwSigBuf[PwSigIn].y = PwSigBuf[PwSigOut].y;
		PwSigBuf[PwSigIn].status = PwSigBuf[PwSigOut].status;

		PwSigIn++;
		if (PWSIGBUFSIZE <= PwSigIn){
			PwSigIn = 0;
		}
		if (PwSigIn == PwSigOut){
			PwSigIn--;
			if (PwSigIn < 0){
				PwSigIn = PWSIGBUFSIZE - 1;
			}
		}
	}

	ExclFlag = EXCL_OFF;
	return 0;
}

/*
	@  \F	VOi荞݊֐
*/
int		PwIntercept(signum)
int		signum;
{
	PWIN			*win;
	int				x,y;
	
	PwSignalCode = signum;

	if (ExclFlag == EXCL_ON){
		return 0;
	}

	ExclFlag = EXCL_ON;

	win = (PwGetRootWin())->nextwin;	
	do{
		if (win->sigbase <= signum && signum <= win->sigbase + WIN_KEYIN_B){
			break;
		}
		win = win->nextwin;
	}while (win != (PWIN *)NULL);

	if (win == (PWIN *)NULL){
		win = PwGetRootWin();	
		PwSigBuf[PwSigIn].status = _pw_pos(win->path,&x,&y);
		PwSigBuf[PwSigIn].type = signum;
		PwSigBuf[PwSigIn].win = win;
		PwSigBuf[PwSigIn].key = -1;
		PwSigBuf[PwSigIn].x = x;
		PwSigBuf[PwSigIn].y = y;
	}else{
		PwSigBuf[PwSigIn].status = _pw_pos(win->path,&x,&y);
		PwSigBuf[PwSigIn].type = (signum - PWSIGBASE) % (WIN_KEYIN_B + 1) + \
								 PWSIGBASE;
		PwSigBuf[PwSigIn].win = win;
		PwSigBuf[PwSigIn].key = -1;
		PwSigBuf[PwSigIn].x = x;
		PwSigBuf[PwSigIn].y = y;
	}

	PwSigIn++;
	if (PWSIGBUFSIZE <= PwSigIn){
		PwSigIn = 0;
	}
	if (PwSigIn == PwSigOut){
		PwSigIn--;
		if (PwSigIn < 0){
			PwSigIn = PWSIGBUFSIZE - 1;
		}
	}
	ExclFlag = EXCL_OFF;

	return 0;
}

/*
	@  \F	C^[oԊuw肷B
*/
int		PwSetIntervalTime(tick)
unsigned int	tick;
{
	return (PwSleepTick = tick);
}

/*
	@  \F	VOiL[̎c萔ԂB
*/
int		PwPendingSignal()
{
	return PwSigIn - PwSigOut < 0 ? PwSigIn - PwSigOut + PWSIGBUFSIZE : \
									PwSigIn - PwSigOut;
}

/*
	@  \F	VOiL[̎cpB
*/
int		PwScratchSignal()
{
	int		signum;

	signum = PwPendingSignal();
	PwSigOut = PwSigIn;

	return signum;
}
