/*
 *	nr|X^wUWOOO p[\iEBhE䃉Cu[
 *
 *					By WADACHI in moto0717@motokho-net
 *								  pde02650@nifty-serve
 *
 *			91/??/?? VER.1.00	first release
 * 
 */
#include	<stdio.h>
#include	<modes.h>
#include	<pwindow.h>
#include	"PwGraph.h"
#include	"PwControl.h"
#include	"PwSignal.h"
#include	"PwToolKit.h"

#define		PWTOPLEVEL	0

#define		PWOPEN		0
#define		PWCLOSE		1

#define		FD_STDIN	0
#define		FD_STDOUT	1
#define		FD_STDERR	2

#define		MIN_X	8
#define		MIN_Y	(8+20)
#define		MAX_X	(1024-8-4)
#define		MAX_Y	(1024-8-4)

PWIN		*PwRootWin;
PWIN		*PwMasterWin;

/*
	@  \F	ݒsB
*/
int		PwInitWin()
{
	int		left,top,right,bottom,status;
	char	name[32];
	
	if ((PwRootWin = (PWIN *)calloc(1,sizeof (PWIN))) == (PWIN *)NULL){
		return -1;
	}

	if ((PwRootWin->path = open("/win",S_IREAD|S_IWRITE)) == -1){
		return -1;
	}

	_pw_status(PwRootWin->path,WIN_DEF_ID,&left,&top,&right,&bottom,&status);

	PwRootWin->level = PWTOPLEVEL;
	PwRootWin->mastwin = (PWIN *)NULL;
	PwRootWin->prewin = (PWIN *)NULL;
	PwRootWin->nextwin = (PWIN *)NULL;
	PwRootWin->left = left;
	PwRootWin->top = top;
	PwRootWin->width = right - left;
	PwRootWin->height = bottom - top;

	PwRootWin->pwcntl = (struct st_pwcntl *)NULL;

	if ((PwMasterWin = (PWIN *)calloc(1,sizeof (PWIN))) == (PWIN *)NULL){
		return -1;
	}

	PwMasterWin->path = dup(FD_STDOUT);

	_pw_status(PwMasterWin->path,WIN_DEF_ID,&left,&top,&right,&bottom,&status);

	PwMasterWin->level = PwRootWin->level + 1;
	_gs_devn(PwMasterWin->path,name);
	PwMasterWin->sigbase = PWSIGBASE + atoi(name + 4) * (WIN_KEYIN_B + 1);
	PwMasterWin->sigmask = 0;
	PwMasterWin->mastwin = PwRootWin;
	PwMasterWin->prewin = PwRootWin;
	PwMasterWin->prewin->nextwin = PwMasterWin;
	PwMasterWin->nextwin = (PWIN *)NULL;
	PwMasterWin->title = "shell";
	PwMasterWin->left = left;
	PwMasterWin->top = top;
	PwMasterWin->width = right - left;
	PwMasterWin->height = bottom - top;
	PwMasterWin->mapmode = status & \
					(WIN_MP_TITLE|WIN_MP_SCREEN|WIN_MP_SHADEB|WIN_MP_SHADER);
	PwMasterWin->winmode = status & \
					(WIN_CHGMAP|WIN_LOCATE|WIN_SIZE|WIN_PRIORITY|WIN_DESTROY);
	PwMasterWin->status = PWOPEN;

	PwMasterWin->pwcntl = (struct st_pwcntl *)NULL;

	return 0;
}	

/*
	@  \F	IsB
*/
int		PwTermWin()
{
	int		_PwDestroyAllWin();
	
	_PwDestroyAllWin();
	close(PwRootWin->path);
	free(PwRootWin);
	free(PwMasterWin);
	return 0;
}	

/*
	@  \F	RootWindow PWIN ւ̃|C^[ԂB
*/
PWIN	*PwGetRootWin()
{
	return PwRootWin;
}

/*
	@  \F	MasterWindow  PWIN ւ̃|C^[ԂB
*/
PWIN	*PwGetMasterWin()
{
	return PwMasterWin;
}

/*
	@  \F	PWIN 쐬B
*/
PWIN	*PwCreateWin(mwin,left,top,width,height)
PWIN	*mwin;
int		left;
int		top;
int		width;
int		height;
{
	PWIN	*pwin,*win;
	char	name[32];
	
	if (mwin == (PWIN *)NULL){
		return (PWIN *)NULL;
	}

	if ((pwin = (PWIN *)calloc(1,sizeof (PWIN))) == (PWIN *)NULL){
		return ((PWIN *)NULL);
	}

	if (_pw_create(PwRootWin->path,WIN_DEF_ID,width,height,0,name)==-1){
		return ((PWIN *)NULL);
	}

	if ((pwin->path = open(name,S_IREAD|S_IWRITE)) == -1){
		return ((PWIN *)NULL);
	}

	win = mwin;
	while (win->nextwin != (PWIN *)NULL && mwin->level < win->nextwin->level){
		win = win->nextwin;
	}

	pwin->level = mwin->level + 1;
	pwin->sigbase = PWSIGBASE + atoi(name + 4) * (WIN_KEYIN_B + 1);
	pwin->sigmask = 0;
	pwin->mastwin = mwin;
	pwin->prewin = win;
	pwin->nextwin = win->nextwin;
	win->nextwin = pwin;
	if (pwin->nextwin != (PWIN *)NULL){
		pwin->nextwin->prewin = pwin;
	}
	pwin->title = "";
	pwin->left = left;
	pwin->top = top;
	pwin->width = width;
	pwin->height = height;
	pwin->mapmode = WIN_MP_TITLE|WIN_MP_SCREEN|WIN_MP_SHADEB| \
						 WIN_MP_SHADER;
	pwin->winmode = WIN_CHGMAP|WIN_LOCATE|WIN_SIZE|WIN_PRIORITY| \
						 WIN_DESTROY;
	pwin->status = PWCLOSE;

	pwin->pwcntl = (struct st_pwcntl *)NULL;

	return (pwin);
}	

/*
	@  \F	Window ݒ肷B
*/
int		PwSetWinAttr(pwin,winattr)
PWIN	*pwin;
int		winattr;
{
	if (pwin == (PWIN *)NULL){
		return -1;
	}
	
	pwin->mapmode = winattr & \
					(WIN_MP_TITLE|WIN_MP_SCREEN|WIN_MP_SHADEB|WIN_MP_SHADER);
	if (pwin->status == PWOPEN){
		_pw_map(pwin->path,WIN_DEF_ID,pwin->mapmode);
	}

	pwin->winmode = winattr & \
					(WIN_CHGMAP|WIN_LOCATE|WIN_SIZE|WIN_PRIORITY|WIN_DESTROY);
	_pw_setmode(pwin->path,WIN_DEF_ID,pwin->winmode);

	return 0;
}

/*
	@  \F	Window ̃^Cgݒ肷B
*/
int		PwSetWinTitle(pwin,title)
PWIN	*pwin;
char	*title;
{
	int		ret;
	
	if (pwin == (PWIN *)NULL || title == (char *)NULL){
		return -1;
	}

	pwin->title = title;
	ret = _pw_name(pwin->path,WIN_DEF_ID,pwin->title);
	return ret;
}

/*
	@  \F	Window  stdin,stdout,stderr 蓖ĂB
*/
int		PwSetStdPath(pwin,mode)
PWIN	*pwin;
int		mode;
{
	if (pwin == (PWIN *)NULL){
		return -1;
	}
	
	if (mode & MSK_STDIN){
		close(FD_STDIN);
		if (dup(pwin->path) != FD_STDIN){
			return (-1);
		}
	}
	if (mode & MSK_STDOUT){
		close(FD_STDOUT);
		if (dup(pwin->path) != FD_STDOUT){
			return (-1);
		}
	}
	if (mode & MSK_STDERR){
		close(FD_STDERR);
		if (dup(pwin->path) != FD_STDERR){
			return (-1);
		}
	}

	return 0;
}

/*
	@  \F	Window I[vB
*/
int		PwOpenWin(pwin)
PWIN	*pwin;
{
	int		left,top,right,bottom,status,locleft,loctop;
	PWIN	*win;
	
	if (pwin == (PWIN *)NULL){
		return -1;
	}

	win = pwin;
	do{
		_pw_signal(win->path,WIN_DEF_ID,win->sigbase,0);

		_pw_status(win->mastwin->path,WIN_DEF_ID,&left,&top,&right, \
				   &bottom,&status);

		locleft = left + win->left;
		if (locleft < MIN_X){
			locleft = MIN_X;
			win->left = MIN_X - left;
		}
		if (MAX_X < (locleft + win->width)){
			locleft = MAX_X - win->width;
			win->left = MAX_X - left - win->width;
		}
		loctop = top + win->top;
		if (loctop < MIN_Y){
			loctop = MIN_Y;
			win->top = MIN_Y - top;
		}
		if (MAX_Y < (loctop + win->height)){
			loctop = MAX_Y - win->height;
			win->top = MAX_Y - top - win->height;
		}

		_pw_locate(win->path,WIN_DEF_ID,locleft,loctop);

		_pw_name(win->path,WIN_DEF_ID,win->title);

		_pw_setmode(win->path,WIN_DEF_ID,win->winmode);

		_pw_map(win->path,WIN_DEF_ID,win->mapmode);

		_pw_signal(win->path,WIN_DEF_ID,win->sigbase,win->sigmask);

		win->status = PWOPEN;

		win = win->nextwin;

	} while(win != (PWIN *)NULL && pwin->level < win->level);

	return 0;
}

/*
	@  \F	Window I[vi͈̓`FbNjB
*/
int		_PwOpenWin(pwin)
PWIN	*pwin;
{
	int		left,top,right,bottom,status;
	PWIN	*win;
	
	if (pwin == (PWIN *)NULL){
		return -1;
	}

	win = pwin;
	do{
		_pw_signal(win->path,WIN_DEF_ID,win->sigbase,0);

		_pw_status(win->mastwin->path,WIN_DEF_ID,&left,&top,&right, \
				   &bottom,&status);

		_pw_locate(win->path,WIN_DEF_ID,left + win->left,top + win->top);

		_pw_name(win->path,WIN_DEF_ID,win->title);

		_pw_setmode(win->path,WIN_DEF_ID,win->winmode);

		_pw_map(win->path,WIN_DEF_ID,win->mapmode);

		_pw_signal(win->path,WIN_DEF_ID,win->sigbase,win->sigmask);

		win->status = PWOPEN;

		win = win->nextwin;

	} while(win != (PWIN *)NULL && pwin->level < win->level);

	return 0;
}

/*
	@  \F	Window N[YB
*/
int		PwCloseWin(pwin)
PWIN	*pwin;
{
	PWIN	*win;
	
	if (pwin == (PWIN *)NULL){
		return -1;
	}

	win = pwin;
	do{
		_pw_signal(win->path,WIN_DEF_ID,win->sigbase,0);

		_pw_map(win->path,WIN_DEF_ID,0);

		win->status = PWCLOSE;

		_pw_signal(win->path,WIN_DEF_ID,win->sigbase,win->sigmask);

		win = win->nextwin;
	}while (win != (PWIN *)NULL && pwin->level < win->level);

	return 0;
}

/*
	@  \F	Window j󂷂B
*/
int		PwDestroyWin(pwin)
PWIN	*pwin;
{
	int		pwin_level;
	PWIN	*win,*pwin_prewin,*nextwin;
	
	if (pwin == (PWIN *)NULL){
		return -1;
	}

	pwin_level = pwin->level;
	pwin_prewin = pwin->prewin;

	win = pwin;
	do{
		_pw_signal(win->path,WIN_DEF_ID,win->sigbase,0);

		_pw_destroy(win->path,WIN_DEF_ID);
		close(win->path);

		nextwin = win->nextwin;
		_PwDestroyAllControl(win->pwcntl);
		free(win);

		win = nextwin;
	}while (win != (PWIN *)NULL && pwin_level < win->level);

	pwin_prewin->nextwin = win;
	if (win != (PWIN *)NULL){
		win->prewin = pwin_prewin;
	}

	return 0;
}

/*
	@  \F	SĂ Window j󂷂B
*/
int		_PwDestroyAllWin()
{
	PWIN	*win,*nextwin;
	
	if (PwMasterWin == (PWIN *)NULL){
		return 0;
	}

	win = PwMasterWin->nextwin;
	if (win == (PWIN *)NULL){
		return 0;
	}

	do{
		_pw_signal(win->path,WIN_DEF_ID,win->sigbase,0);

		_pw_destroy(win->path,WIN_DEF_ID);
		close(win->path);

		nextwin = win->nextwin;
		_PwDestroyAllControl(win->pwcntl);
		free(win);

		win = nextwin;
	}while (win != (PWIN *)NULL);

	return 0;
}

/*
	@  \F	Window ړB
*/
int		PwMoveWin(pwin,left,top)
PWIN	*pwin;
int		left;
int		top;
{
	int		mleft,mtop,mright,mbottom,mstatus,locleft,loctop;
	PWIN	*win;
	
	if (pwin == (PWIN *)NULL){
		return -1;
	}

	win = pwin;
	do{
		_pw_signal(win->path,WIN_DEF_ID,win->sigbase,0);

		_pw_status(win->mastwin->path,WIN_DEF_ID,&mleft,&mtop,&mright, \
				   &mbottom,&mstatus);
		if (win == pwin){
			win->left = left;
			win->top = top;
		}

		locleft = mleft + win->left;
		if (locleft < MIN_X){
			locleft = MIN_X;
			win->left = MIN_X - mleft;
		}
		if (MAX_X < (locleft + win->width)){
			locleft = MAX_X - win->width;
			win->left = MAX_X - left - win->width;
		}
		loctop = mtop + win->top;
		if (loctop < MIN_Y){
			loctop = MIN_Y;
			win->top = MIN_Y - mtop;
		}
		if (MAX_Y < (loctop + win->height)){
			loctop = MAX_Y - win->height;
			win->top = MAX_Y - top - win->height;
		}

		_pw_locate(win->path,WIN_DEF_ID,locleft,loctop);

		_pw_signal(win->path,WIN_DEF_ID,win->sigbase,win->sigmask);

		win = win->nextwin;
	} while(win != (PWIN *)NULL && pwin->level < win->level);

	return 0;
}

/*
	@  \F	Window ړi͈̓`FbNjB
*/
int		_PwMoveWin(pwin,left,top)
PWIN	*pwin;
int		left;
int		top;
{
	int		mleft,mtop,mright,mbottom,mstatus;
	PWIN	*win;
	
	if (pwin == (PWIN *)NULL){
		return -1;
	}

	win = pwin;
	do{
		_pw_signal(win->path,WIN_DEF_ID,win->sigbase,0);

		_pw_status(win->mastwin->path,WIN_DEF_ID,&mleft,&mtop,&mright, \
				   &mbottom,&mstatus);
		if (win == pwin){
			win->left = left;
			win->top = top;
		}

		_pw_locate(win->path,WIN_DEF_ID,mleft + win->left,mtop + win->top);

		_pw_signal(win->path,WIN_DEF_ID,win->sigbase,win->sigmask);

		win = win->nextwin;
	} while(win != (PWIN *)NULL && pwin->level < win->level);

	return 0;
}

/*
	@  \F	Window ĕ`悷B
*/
int		PwRedrawWin(pwin)
PWIN	*pwin;
{
	int		pleft,ptop,pwidth,pheight,pstatus;
	
	if (pwin == (PWIN *)NULL){
		return -1;
	}

	PwGetWinStatus(pwin,&pleft,&ptop,&pwidth,&pheight,&pstatus);

	PwMoveWin(pwin,pleft,ptop);

	return 0;
}
		
/*
	@  \F	Window pX擾B
*/
int		PwGetWinPath(pwin)
PWIN	*pwin;
{
	if (pwin == (PWIN *)NULL){
		return -1;
	}
	
	return pwin->path;
}

/*
	@  \F	Window TCYύXB
*/
int		PwResizeWin(pwin,width,height)
PWIN	*pwin;
int		width;
int		height;
{
	int		ret;
	
	if (pwin == (PWIN *)NULL){
		return -1;
	}

	_pw_signal(pwin->path,WIN_DEF_ID,pwin->sigbase,0);

	pwin->width = width;
	pwin->height = height;
	ret = _pw_size(pwin->path,WIN_DEF_ID,width,height);

	_pw_signal(pwin->path,WIN_DEF_ID,pwin->sigbase,pwin->sigmask);

	return ret;
}

/*
	@  \F	Window 擾BB
*/
int		PwGetWinStatus(pwin,left,top,width,height,winattr)
PWIN	*pwin;
int		*left;
int		*top;
int		*width;
int		*height;
int		*winattr;
{
	int		pleft,ptop,pright,pbottom,pstatus,mleft,mtop,mright,mbottom, \
			mstatus;
			
	if (pwin == (PWIN *)NULL || \
		left == (int *)NULL || \
		top == (int *)NULL || \
		width == (int *)NULL || \
		height == (int *)NULL || \
		winattr == (int *)NULL){
		return -1;
	}

	_pw_status(pwin->mastwin->path,WIN_DEF_ID,&mleft,&mtop,&mright, \
			   &mbottom,&mstatus);
	_pw_status(pwin->path,WIN_DEF_ID,&pleft,&ptop,&pright,&pbottom, \
			   &pstatus);
	*left = pwin->left = pleft - mleft;
	*top = pwin->top = ptop - mtop;
	*width = pwin->width = pright - pleft;
	*height = pwin->height = pbottom - ptop;
	*winattr = pstatus;
	pwin->mapmode = pstatus & \
					(WIN_MP_TITLE|WIN_MP_SCREEN|WIN_MP_SHADEB|WIN_MP_SHADER);
	pwin->winmode = pstatus & \
					(WIN_CHGMAP|WIN_LOCATE|WIN_SIZE|WIN_PRIORITY|WIN_DESTROY);

	return 0;
}

/*
	@  \F	Window ̎ẅNA[B
*/
int		PwClearWinArea(pwin,left,top,width,height)
PWIN	*pwin;
int		left;
int		top;
int		width;
int		height;
{
	int		ret;
	
	if (pwin == (PWIN *)NULL){
		return -1;
	}

	ret = _pw_clear(pwin->path,WIN_DEF_ID,left,top,left+width,top+height);
	return ret;
}

/*
	@  \F	Window NA[B
*/
int		PwClearWin(pwin)
PWIN	*pwin;
{
	int		ret;
	
	if (pwin == (PWIN *)NULL){
		return -1;
	}

	ret = PwClearWinArea(pwin,1,1,pwin->width - 2,pwin->height - 2);
	return ret;
}

/*
	@  \F	Window obNXg[Wẅւ|oB
*/
int		PwFlushWinArea(pwin,left,top,width,height,reverse)
PWIN	*pwin;
int		left;
int		top;
int		width;
int		height;
int		reverse;
{
	int		ret;
	
	if (pwin == (PWIN *)NULL){
		return -1;
	}

	ret = _pw_flush(pwin->path,WIN_DEF_ID,left,top,left+width,top+height, \
					  reverse);
	return ret;
}

/*
	@  \F	Window obNXg[W|oB
*/
int		PwFlushWin(pwin,reverse)
PWIN	*pwin;
int		reverse;
{
	int		ret;
	
	if (pwin == (PWIN *)NULL){
		return -1;
	}

	ret = PwFlushWinArea(pwin,1,1,pwin->width-2,pwin->height-2,reverse);
	return ret;
}

/*
	@  \F	Window ẅ̃C[W擾B
*/
int		PwGetWinImage(pwin,buf,rowbytes,left,top,width,height)
PWIN			*pwin;
unsigned char	*buf;
int				rowbytes;
int				left;
int				top;
int				width;
int				height;
{
	int		ret;
	
	if (pwin == (PWIN *)NULL || buf == (unsigned char *)NULL){
		return -1;
	}

	ret = _pw_imgget(pwin->path,WIN_DEF_ID,buf,rowbytes,left,top,\
					left + width,top + height);
	return ret;
}

/*
	@  \F	Window ẅɃC[W𕡎ʂB
*/
int		PwPutWinImage(pwin,buf,rowbytes,left,top,width,height)
PWIN			*pwin;
unsigned char	*buf;
int				rowbytes;
int				left;
int				top;
int				width;
int				height;
{
	int		ret;

	if (pwin == (PWIN *)NULL || buf == (unsigned char *)NULL){
		return -1;
	}

	ret = _pw_imgput(pwin->path,WIN_DEF_ID,buf,rowbytes,left,top, \
					   left + width,top + height);
	return ret;
}

/*
	@  \F	Window ̗D揇ʂύXB
*/
int		PwChangeWinPriority(pwin,sw)
PWIN	*pwin;
int		sw;
{
	PWIN	*_PwGetLastWin();
	PWIN	*win;
	
	if (pwin == (PWIN *)NULL){
		return -1;
	}

	if (sw == WIN_PRIORITY_TOP){
		win = pwin;
		do{
			_pw_signal(win->path,WIN_DEF_ID,win->sigbase,0);
	
			_pw_prio(win->path,WIN_DEF_ID,sw);
	
			_pw_signal(win->path,WIN_DEF_ID,win->sigbase,win->sigmask);
	
			win = win->nextwin;
		} while(win != (PWIN *)NULL && pwin->level < win->level);
	}else{
		win = _PwGetLastWin(pwin);
		do{
			_pw_signal(win->path,WIN_DEF_ID,win->sigbase,0);
	
			_pw_prio(win->path,WIN_DEF_ID,sw);
	
			_pw_signal(win->path,WIN_DEF_ID,win->sigbase,win->sigmask);
	
			win = win->prewin;
		} while(win != (PWIN *)NULL && win->nextwin < pwin);
	}

	return 0;
}

PWIN	*_PwGetLastWin(pwin)
PWIN	*pwin;
{
	PWIN	*win;
	
	if (pwin == (PWIN *)NULL){
		return (PWIN *)NULL;
	}

	win = pwin;
	while (win->nextwin != (PWIN *)NULL && pwin->level < win->nextwin->level){
		win = win->nextwin;
	}

	return win;
}

/*
	@  \F	Window ɃL[{[h͂Œ肷B
*/
int		PwLockWin(pwin)
PWIN	*pwin;
{
	int		ret;
	
	if (pwin == (PWIN *)NULL){
		return -1;
	}

	ret = _pw_lock(pwin->path,WIN_DEF_ID,1);
	return ret;
}

/*
	@  \F	PwLockWin() ̎wB
*/
int		PwUnlockWin(pwin)
PWIN	*pwin;
{
	int		ret;
	
	if (pwin == (PWIN *)NULL){
		return -1;
	}

	ret = _pw_lock(pwin->path,WIN_DEF_ID,0);
	return ret;
}

/*
	@  \F	Window ɑ΂zL[{[h͂sB
*/
int		PwPutString(pwin,string)
PWIN	*pwin;
char	*string;
{
	int		ret;
	
	if (pwin == (PWIN *)NULL || string == (char *)NULL){
		return -1;
	}

	if (strlen(string)){
		ret = _pw_putstr(pwin->path,WIN_DEF_ID,strlen(string),string);
		return ret;
	}
	return 0;
}

/*
	@  \F	}EXJ[\̈ʒu擾B
*/
int		PwGetMousePosition(pwin,left,top)
PWIN	*pwin;
int		*left;
int		*top;
{
	int		ret;

	if (pwin == (PWIN *)NULL || left == (int *)NULL || top == (int *)NULL){
		return -1;
	}

	ret = _pw_pos(pwin->path,left,top);
	return ret;
}

/*
	@  \F	}EXJ[\̌`ݒ肷B
*/
int		PwSetCursorPattern(pwin,hitx,hity,pattern)
PWIN			*pwin;
int				hitx;
int				hity;
unsigned char	pattern[][2];
{
	int		ret;
	
	if (pwin == (PWIN *)NULL){
		return -1;
	}

	ret = _pw_setcptn(pwin->path,WIN_DEF_ID,hitx,hity,pattern);
	return ret;
}

/*
	@  \F	}EXJ[\̈ړXs[hݒ肷B
*/
int		PwSetCursorSpeed(pwin,value)
PWIN	*pwin;
int		value;
{
	int		ret;

	if (pwin == (PWIN *)NULL){
		return -1;
	}

	ret = _pw_turbo(pwin->path,value);
	return ret;
}

/*
	@  \F	Window ̃eLXg}[Wݒ肷B
*/
int		PwSetTextMargin(pwin,left,top,right,bottom)
PWIN	*pwin;
int		left;
int		top;
int		right;
int		bottom;
{
	int		ret;

	if (pwin == (PWIN *)NULL){
		return -1;
	}

	ret = _pw_margin(pwin->path,WIN_DEF_ID,left,top,right,bottom);
	return ret;
}

/* 
	@  \F	PWIN\̂̃Rs[
*/
int		_PwCopyPwin(src_pwin,dst_pwin)
PWIN	*src_pwin;
PWIN	*dst_pwin;
{
	int		i;

	if (src_pwin == (PWIN *)NULL || dst_pwin == (PWIN *)NULL){
		return -1;
	}

	for (i = 0;i < sizeof (PWIN);i++){
		*(((char *)dst_pwin)++) = *(((char *)src_pwin)++);
	}
	return 0;
}

/* ------------     NOT RELEASE    ------------------
int		PwSetWinBackground(pwin,background)
PWIN			*pwin;
unsigned char	background[][2];
{
	_pw_setbgptn(pwin->path,background);
	return 0;
}

int		PwGetWinBackground(pwin,background)
PWIN			*pwin;
unsigned char	background[][2];
{
	_pw_getbgptn(pwin->path,background);
	return 	0;
}

int		PwGetCursorPattern(pwin,pattern)
PWIN			*pwin;
unsigned char	*pattern[][2];
{
	_pw_getcptn(pwin->path,pattern);
	return 0;
}
------------------------------------------------------ */
